/**
 * <copyright>
 * </copyright>
 *
 * $Id: PageImpl.java 8635 2011-11-03 21:04:39Z hoenninger $
 */
package org.openxma.dsl.pom.model.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;
import org.openxma.dsl.core.CorePackage;
import org.openxma.dsl.core.model.IDocumentable;
import org.openxma.dsl.core.model.impl.ReferenceableByXmadslVariableImpl;
import org.openxma.dsl.dom.model.ConditionsBlock;
import org.openxma.dsl.pom.PomPackage;
import org.openxma.dsl.pom.model.Command;
import org.openxma.dsl.pom.model.ComposeData;
import org.openxma.dsl.pom.model.Composite;
import org.openxma.dsl.pom.model.Content;
import org.openxma.dsl.pom.model.DataMappingList;
import org.openxma.dsl.pom.model.DataObjectVariable;
import org.openxma.dsl.pom.model.Definitions;
import org.openxma.dsl.pom.model.EventMappingList;
import org.openxma.dsl.pom.model.GuiElement;
import org.openxma.dsl.pom.model.Invokeable;
import org.openxma.dsl.pom.model.Page;
import org.openxma.dsl.pom.model.PageDefinition;


/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Page</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.openxma.dsl.pom.model.impl.PageImpl#getContent <em>Content</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.PageImpl#getTxtDescription <em>Txt Description</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.PageImpl#getComposeLayout <em>Compose Layout</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.PageImpl#getDataobjects <em>Dataobjects</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.PageImpl#getDataMapping <em>Data Mapping</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.PageImpl#getCommands <em>Commands</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.PageImpl#getEvents <em>Events</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.PageImpl#getConditionsBlock <em>Conditions Block</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.PageImpl#getDefinitions <em>Definitions</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class PageImpl extends ReferenceableByXmadslVariableImpl implements Page {
	/**
	 * The cached value of the '{@link #getContent() <em>Content</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getContent()
	 * @generated
	 * @ordered
	 */
	protected Content content;

	/**
	 * The default value of the '{@link #getTxtDescription() <em>Txt Description</em>}' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getTxtDescription()
	 * @generated
	 * @ordered
	 */
    protected static final String TXT_DESCRIPTION_EDEFAULT = null;

    /**
	 * The cached value of the '{@link #getTxtDescription() <em>Txt Description</em>}' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getTxtDescription()
	 * @generated
	 * @ordered
	 */
    protected String txtDescription = TXT_DESCRIPTION_EDEFAULT;

    /**
	 * The cached value of the '{@link #getComposeLayout() <em>Compose Layout</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getComposeLayout()
	 * @generated
	 * @ordered
	 */
	protected ComposeData composeLayout;

	/**
	 * The cached value of the '{@link #getDataobjects() <em>Dataobjects</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDataobjects()
	 * @generated
	 * @ordered
	 */
	protected EList<DataObjectVariable> dataobjects;

	/**
	 * The cached value of the '{@link #getDataMapping() <em>Data Mapping</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDataMapping()
	 * @generated
	 * @ordered
	 */
	protected DataMappingList dataMapping;

	/**
	 * The cached value of the '{@link #getCommands() <em>Commands</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCommands()
	 * @generated
	 * @ordered
	 */
	protected EList<Command> commands;

	/**
	 * The cached value of the '{@link #getEvents() <em>Events</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEvents()
	 * @generated
	 * @ordered
	 */
	protected EventMappingList events;

	/**
	 * The cached value of the '{@link #getConditionsBlock() <em>Conditions Block</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getConditionsBlock()
	 * @generated
	 * @ordered
	 */
	protected ConditionsBlock conditionsBlock;

	/**
	 * The cached value of the '{@link #getDefinitions() <em>Definitions</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDefinitions()
	 * @generated
	 * @ordered
	 */
	protected Definitions definitions;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected PageImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return PomPackage.Literals.PAGE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ComposeData getComposeLayout() {
		return composeLayout;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetComposeLayout(ComposeData newComposeLayout, NotificationChain msgs) {
		ComposeData oldComposeLayout = composeLayout;
		composeLayout = newComposeLayout;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, PomPackage.PAGE__COMPOSE_LAYOUT, oldComposeLayout, newComposeLayout);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setComposeLayout(ComposeData newComposeLayout) {
		if (newComposeLayout != composeLayout) {
			NotificationChain msgs = null;
			if (composeLayout != null)
				msgs = ((InternalEObject)composeLayout).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - PomPackage.PAGE__COMPOSE_LAYOUT, null, msgs);
			if (newComposeLayout != null)
				msgs = ((InternalEObject)newComposeLayout).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - PomPackage.PAGE__COMPOSE_LAYOUT, null, msgs);
			msgs = basicSetComposeLayout(newComposeLayout, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.PAGE__COMPOSE_LAYOUT, newComposeLayout, newComposeLayout));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<DataObjectVariable> getDataobjects() {
		if (dataobjects == null) {
			dataobjects = new EObjectContainmentEList<DataObjectVariable>(DataObjectVariable.class, this, PomPackage.PAGE__DATAOBJECTS);
		}
		return dataobjects;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DataMappingList getDataMapping() {
		return dataMapping;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetDataMapping(DataMappingList newDataMapping, NotificationChain msgs) {
		DataMappingList oldDataMapping = dataMapping;
		dataMapping = newDataMapping;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, PomPackage.PAGE__DATA_MAPPING, oldDataMapping, newDataMapping);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDataMapping(DataMappingList newDataMapping) {
		if (newDataMapping != dataMapping) {
			NotificationChain msgs = null;
			if (dataMapping != null)
				msgs = ((InternalEObject)dataMapping).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - PomPackage.PAGE__DATA_MAPPING, null, msgs);
			if (newDataMapping != null)
				msgs = ((InternalEObject)newDataMapping).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - PomPackage.PAGE__DATA_MAPPING, null, msgs);
			msgs = basicSetDataMapping(newDataMapping, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.PAGE__DATA_MAPPING, newDataMapping, newDataMapping));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Command> getCommands() {
		if (commands == null) {
			commands = new EObjectContainmentEList<Command>(Command.class, this, PomPackage.PAGE__COMMANDS);
		}
		return commands;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EventMappingList getEvents() {
		return events;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetEvents(EventMappingList newEvents, NotificationChain msgs) {
		EventMappingList oldEvents = events;
		events = newEvents;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, PomPackage.PAGE__EVENTS, oldEvents, newEvents);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setEvents(EventMappingList newEvents) {
		if (newEvents != events) {
			NotificationChain msgs = null;
			if (events != null)
				msgs = ((InternalEObject)events).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - PomPackage.PAGE__EVENTS, null, msgs);
			if (newEvents != null)
				msgs = ((InternalEObject)newEvents).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - PomPackage.PAGE__EVENTS, null, msgs);
			msgs = basicSetEvents(newEvents, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.PAGE__EVENTS, newEvents, newEvents));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ConditionsBlock getConditionsBlock() {
		return conditionsBlock;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetConditionsBlock(ConditionsBlock newConditionsBlock, NotificationChain msgs) {
		ConditionsBlock oldConditionsBlock = conditionsBlock;
		conditionsBlock = newConditionsBlock;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, PomPackage.PAGE__CONDITIONS_BLOCK, oldConditionsBlock, newConditionsBlock);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setConditionsBlock(ConditionsBlock newConditionsBlock) {
		if (newConditionsBlock != conditionsBlock) {
			NotificationChain msgs = null;
			if (conditionsBlock != null)
				msgs = ((InternalEObject)conditionsBlock).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - PomPackage.PAGE__CONDITIONS_BLOCK, null, msgs);
			if (newConditionsBlock != null)
				msgs = ((InternalEObject)newConditionsBlock).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - PomPackage.PAGE__CONDITIONS_BLOCK, null, msgs);
			msgs = basicSetConditionsBlock(newConditionsBlock, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.PAGE__CONDITIONS_BLOCK, newConditionsBlock, newConditionsBlock));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Content getContent() {
		return content;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetContent(Content newContent, NotificationChain msgs) {
		Content oldContent = content;
		content = newContent;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, PomPackage.PAGE__CONTENT, oldContent, newContent);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setContent(Content newContent) {
		if (newContent != content) {
			NotificationChain msgs = null;
			if (content != null)
				msgs = ((InternalEObject)content).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - PomPackage.PAGE__CONTENT, null, msgs);
			if (newContent != null)
				msgs = ((InternalEObject)newContent).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - PomPackage.PAGE__CONTENT, null, msgs);
			msgs = basicSetContent(newContent, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.PAGE__CONTENT, newContent, newContent));
	}

	/**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public String getTxtDescription() {
		return txtDescription;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public void setTxtDescription(String newTxtDescription) {
		String oldTxtDescription = txtDescription;
		txtDescription = newTxtDescription;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.PAGE__TXT_DESCRIPTION, oldTxtDescription, txtDescription));
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Definitions getDefinitions() {
		return definitions;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetDefinitions(Definitions newDefinitions, NotificationChain msgs) {
		Definitions oldDefinitions = definitions;
		definitions = newDefinitions;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, PomPackage.PAGE__DEFINITIONS, oldDefinitions, newDefinitions);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDefinitions(Definitions newDefinitions) {
		if (newDefinitions != definitions) {
			NotificationChain msgs = null;
			if (definitions != null)
				msgs = ((InternalEObject)definitions).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - PomPackage.PAGE__DEFINITIONS, null, msgs);
			if (newDefinitions != null)
				msgs = ((InternalEObject)newDefinitions).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - PomPackage.PAGE__DEFINITIONS, null, msgs);
			msgs = basicSetDefinitions(newDefinitions, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.PAGE__DEFINITIONS, newDefinitions, newDefinitions));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case PomPackage.PAGE__CONTENT:
				return basicSetContent(null, msgs);
			case PomPackage.PAGE__COMPOSE_LAYOUT:
				return basicSetComposeLayout(null, msgs);
			case PomPackage.PAGE__DATAOBJECTS:
				return ((InternalEList<?>)getDataobjects()).basicRemove(otherEnd, msgs);
			case PomPackage.PAGE__DATA_MAPPING:
				return basicSetDataMapping(null, msgs);
			case PomPackage.PAGE__COMMANDS:
				return ((InternalEList<?>)getCommands()).basicRemove(otherEnd, msgs);
			case PomPackage.PAGE__EVENTS:
				return basicSetEvents(null, msgs);
			case PomPackage.PAGE__CONDITIONS_BLOCK:
				return basicSetConditionsBlock(null, msgs);
			case PomPackage.PAGE__DEFINITIONS:
				return basicSetDefinitions(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case PomPackage.PAGE__CONTENT:
				return getContent();
			case PomPackage.PAGE__TXT_DESCRIPTION:
				return getTxtDescription();
			case PomPackage.PAGE__COMPOSE_LAYOUT:
				return getComposeLayout();
			case PomPackage.PAGE__DATAOBJECTS:
				return getDataobjects();
			case PomPackage.PAGE__DATA_MAPPING:
				return getDataMapping();
			case PomPackage.PAGE__COMMANDS:
				return getCommands();
			case PomPackage.PAGE__EVENTS:
				return getEvents();
			case PomPackage.PAGE__CONDITIONS_BLOCK:
				return getConditionsBlock();
			case PomPackage.PAGE__DEFINITIONS:
				return getDefinitions();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case PomPackage.PAGE__CONTENT:
				setContent((Content)newValue);
				return;
			case PomPackage.PAGE__TXT_DESCRIPTION:
				setTxtDescription((String)newValue);
				return;
			case PomPackage.PAGE__COMPOSE_LAYOUT:
				setComposeLayout((ComposeData)newValue);
				return;
			case PomPackage.PAGE__DATAOBJECTS:
				getDataobjects().clear();
				getDataobjects().addAll((Collection<? extends DataObjectVariable>)newValue);
				return;
			case PomPackage.PAGE__DATA_MAPPING:
				setDataMapping((DataMappingList)newValue);
				return;
			case PomPackage.PAGE__COMMANDS:
				getCommands().clear();
				getCommands().addAll((Collection<? extends Command>)newValue);
				return;
			case PomPackage.PAGE__EVENTS:
				setEvents((EventMappingList)newValue);
				return;
			case PomPackage.PAGE__CONDITIONS_BLOCK:
				setConditionsBlock((ConditionsBlock)newValue);
				return;
			case PomPackage.PAGE__DEFINITIONS:
				setDefinitions((Definitions)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case PomPackage.PAGE__CONTENT:
				setContent((Content)null);
				return;
			case PomPackage.PAGE__TXT_DESCRIPTION:
				setTxtDescription(TXT_DESCRIPTION_EDEFAULT);
				return;
			case PomPackage.PAGE__COMPOSE_LAYOUT:
				setComposeLayout((ComposeData)null);
				return;
			case PomPackage.PAGE__DATAOBJECTS:
				getDataobjects().clear();
				return;
			case PomPackage.PAGE__DATA_MAPPING:
				setDataMapping((DataMappingList)null);
				return;
			case PomPackage.PAGE__COMMANDS:
				getCommands().clear();
				return;
			case PomPackage.PAGE__EVENTS:
				setEvents((EventMappingList)null);
				return;
			case PomPackage.PAGE__CONDITIONS_BLOCK:
				setConditionsBlock((ConditionsBlock)null);
				return;
			case PomPackage.PAGE__DEFINITIONS:
				setDefinitions((Definitions)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case PomPackage.PAGE__CONTENT:
				return content != null;
			case PomPackage.PAGE__TXT_DESCRIPTION:
				return TXT_DESCRIPTION_EDEFAULT == null ? txtDescription != null : !TXT_DESCRIPTION_EDEFAULT.equals(txtDescription);
			case PomPackage.PAGE__COMPOSE_LAYOUT:
				return composeLayout != null;
			case PomPackage.PAGE__DATAOBJECTS:
				return dataobjects != null && !dataobjects.isEmpty();
			case PomPackage.PAGE__DATA_MAPPING:
				return dataMapping != null;
			case PomPackage.PAGE__COMMANDS:
				return commands != null && !commands.isEmpty();
			case PomPackage.PAGE__EVENTS:
				return events != null;
			case PomPackage.PAGE__CONDITIONS_BLOCK:
				return conditionsBlock != null;
			case PomPackage.PAGE__DEFINITIONS:
				return definitions != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass) {
		if (baseClass == PageDefinition.class) {
			switch (derivedFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == GuiElement.class) {
			switch (derivedFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == Composite.class) {
			switch (derivedFeatureID) {
				case PomPackage.PAGE__CONTENT: return PomPackage.COMPOSITE__CONTENT;
				default: return -1;
			}
		}
		if (baseClass == Invokeable.class) {
			switch (derivedFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == IDocumentable.class) {
			switch (derivedFeatureID) {
				case PomPackage.PAGE__TXT_DESCRIPTION: return CorePackage.IDOCUMENTABLE__TXT_DESCRIPTION;
				default: return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass) {
		if (baseClass == PageDefinition.class) {
			switch (baseFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == GuiElement.class) {
			switch (baseFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == Composite.class) {
			switch (baseFeatureID) {
				case PomPackage.COMPOSITE__CONTENT: return PomPackage.PAGE__CONTENT;
				default: return -1;
			}
		}
		if (baseClass == Invokeable.class) {
			switch (baseFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == IDocumentable.class) {
			switch (baseFeatureID) {
				case CorePackage.IDOCUMENTABLE__TXT_DESCRIPTION: return PomPackage.PAGE__TXT_DESCRIPTION;
				default: return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (txtDescription: ");
		result.append(txtDescription);
		result.append(')');
		return result.toString();
	}

} //PageImpl
